Index: src/backend/commands/copy.c
===================================================================
RCS file: /projects/cvsroot/pgsql/src/backend/commands/copy.c,v
retrieving revision 1.245
diff -c -r1.245 copy.c
*** src/backend/commands/copy.c	2 Jun 2005 01:21:22 -0000	1.245
--- src/backend/commands/copy.c	27 Jun 2005 18:45:39 -0000
***************
*** 1,3 ****
--- 1,4 ----
+ 
  /*-------------------------------------------------------------------------
   *
   * copy.c
***************
*** 51,56 ****
--- 52,58 ----
  
  #define ISOCTAL(c) (((c) >= '0') && ((c) <= '7'))
  #define OCTVALUE(c) ((c) - '0')
+ #define COPY_BUF_SIZE 65536
  
  /*
   * Represents the different source/dest cases we need to worry about at
***************
*** 84,90 ****
  	EOL_CRNL
  } EolType;
  
- 
  static const char BinarySignature[11] = "PGCOPY\n\377\r\n\0";
  
  /*
--- 86,91 ----
***************
*** 92,97 ****
--- 93,101 ----
   * never been reentrant...
   */
  static CopyDest copy_dest;
+ static int	eol_ch[2];			/* The byte values of the 1 or 2 eol bytes */
+ static char escapec;			/* escape char for delimited data format. */
+ static bool client_encoding_only;		/* true if client encoding is a non supported server encoding */
  static FILE *copy_file;			/* used if copy_dest == COPY_FILE */
  static StringInfo copy_msgbuf;	/* used if copy_dest == COPY_NEW_FE */
  static bool fe_eof;				/* true if detected end of copy data */
***************
*** 101,156 ****
  
  /* these are just for error messages, see copy_in_error_callback */
  static bool copy_binary;		/* is it a binary copy? */
! static const char *copy_relname;	/* table name for error messages */
  static int	copy_lineno;		/* line number for error messages */
! static const char *copy_attname;	/* current att for error messages */
  
  
  /*
   * These static variables are used to avoid incurring overhead for each
!  * attribute processed.  attribute_buf is reused on each CopyReadAttribute
   * call to hold the string being read in.  Under normal use it will soon
   * grow to a suitable size, and then we will avoid palloc/pfree overhead
   * for subsequent attributes.  Note that CopyReadAttribute returns a pointer
!  * to attribute_buf's data buffer!
   */
! static StringInfoData attribute_buf;
  
  /*
   * Similarly, line_buf holds the whole input line being processed (its
   * cursor field points to the next character to be read by CopyReadAttribute).
   * The input cycle is first to read the whole line into line_buf, convert it
   * to server encoding, and then extract individual attribute fields into
!  * attribute_buf.  (We used to have CopyReadAttribute read the input source
   * directly, but that caused a lot of encoding issues and unnecessary logic
   * complexity.)
   */
! static StringInfoData line_buf;
  static bool line_buf_converted;
  
  /* non-export function prototypes */
  static void DoCopyTo(Relation rel, List *attnumlist, bool binary, bool oids,
! 		 char *delim, char *null_print, bool csv_mode, char *quote,
! 		 char *escape, List *force_quote_atts, bool header_line, bool fe_copy);
  static void CopyTo(Relation rel, List *attnumlist, bool binary, bool oids,
!  char *delim, char *null_print, bool csv_mode, char *quote, char *escape,
! 	   List *force_quote_atts, bool header_line);
  static void CopyFrom(Relation rel, List *attnumlist, bool binary, bool oids,
!  char *delim, char *null_print, bool csv_mode, char *quote, char *escape,
! 		 List *force_notnull_atts, bool header_line);
! static bool CopyReadLine(char * quote, char * escape);
  static char *CopyReadAttribute(const char *delim, const char *null_print,
! 				  CopyReadResult *result, bool *isnull);
  static char *CopyReadAttributeCSV(const char *delim, const char *null_print,
! 					 char *quote, char *escape,
! 					 CopyReadResult *result, bool *isnull);
  static Datum CopyReadBinaryAttribute(int column_no, FmgrInfo *flinfo,
! 						Oid typioparam, bool *isnull);
  static void CopyAttributeOut(char *string, char *delim);
  static void CopyAttributeOutCSV(char *string, char *delim, char *quote,
! 					char *escape, bool force_quote);
  static List *CopyGetAttnums(Relation rel, List *attnamelist);
  static void limit_printout_length(StringInfo buf);
  
  /* Internal communications functions */
  static void SendCopyBegin(bool binary, int natts);
--- 105,189 ----
  
  /* these are just for error messages, see copy_in_error_callback */
  static bool copy_binary;		/* is it a binary copy? */
! static const char *copy_relname;		/* table name for error messages */
  static int	copy_lineno;		/* line number for error messages */
! static const char *copy_attname;		/* current att for error messages */
! 
! /* Static variables for buffered input parsing */
! 
! /* leave room for extra null (to enable use of string functions) */
! static char input_buf[COPY_BUF_SIZE + 1];
! static char *begloc;
! static char *endloc;
! static bool esc_in_prevbuf;		/* backslash was last character of the data input buffer */
! static bool cr_in_prevbuf;		/* CR was last character of the data input buffer */
! static bool line_done;			/* finished processing the whole line or stopped in the middle */
! static bool buf_done;			/* finished processing the current buffer */
! static int	buffer_index;		/* input buffer index */
  
  
  /*
   * These static variables are used to avoid incurring overhead for each
!  * attribute processed.  attr_buf is reused on each CopyReadAttribute
   * call to hold the string being read in.  Under normal use it will soon
   * grow to a suitable size, and then we will avoid palloc/pfree overhead
   * for subsequent attributes.  Note that CopyReadAttribute returns a pointer
!  * to attr_buf's data buffer!
   */
! static StringInfoData attr_buf; /* still used in CopyFrom()		*/
  
  /*
   * Similarly, line_buf holds the whole input line being processed (its
   * cursor field points to the next character to be read by CopyReadAttribute).
   * The input cycle is first to read the whole line into line_buf, convert it
   * to server encoding, and then extract individual attribute fields into
!  * attr_buf.  (We used to have CopyReadAttribute read the input source
   * directly, but that caused a lot of encoding issues and unnecessary logic
   * complexity.)
   */
! static StringInfoData line_buf; /* still used in CopyFromBinary/CSV() */
  static bool line_buf_converted;
  
  /* non-export function prototypes */
  static void DoCopyTo(Relation rel, List *attnumlist, bool binary, bool oids,
! 					 char *delim, char *null_print, bool csv_mode, char *quote,
! 					 char *escape, List *force_quote_atts, bool header_line,
! 					 bool fe_copy);
  static void CopyTo(Relation rel, List *attnumlist, bool binary, bool oids,
! 				   char *delim, char *null_print, bool csv_mode, char *quote,
! 				   char *escape, List *force_quote_atts, bool header_line);
  static void CopyFrom(Relation rel, List *attnumlist, bool binary, bool oids,
! 					 char *delim, char *null_print, bool csv_mode, char *quote,
! 					 char *escape, List *force_notnull_atts, bool header_line);
! static bool CopyReadLine(char *quote, char *escape);
  static char *CopyReadAttribute(const char *delim, const char *null_print,
! 							   CopyReadResult *result, bool *isnull);
  static char *CopyReadAttributeCSV(const char *delim, const char *null_print,
! 								  char *quote, char *escape,
! 								  CopyReadResult *result, bool *isnull);
  static Datum CopyReadBinaryAttribute(int column_no, FmgrInfo *flinfo,
! 									 Oid typioparam, bool *isnull);
  static void CopyAttributeOut(char *string, char *delim);
  static void CopyAttributeOutCSV(char *string, char *delim, char *quote,
! 								char *escape, bool force_quote);
  static List *CopyGetAttnums(Relation rel, List *attnamelist);
  static void limit_printout_length(StringInfo buf);
+ static bool CopyReadLineBuffered(size_t bytesread);
+ static void CopyFromDelimited(Relation rel, List *attnumlist, bool binary,
+ 							  bool oids, char *delim, char *null_print,
+ 							  bool csv_mode, char *quote, char *escape,
+ 							  List *force_notnull_atts);
+ static char *CopyReadAttribute(const char *delim, const char *null_print,
+ 							   CopyReadResult *result, bool *isnull);
+ static void CopyReadAllAttrs(const char *delim, const char *null_print,
+ 							 int null_print_len, char *nulls, List *attnumlist,
+ 							 int *attr_offsets, int num_phys_attrs,
+ 							 Form_pg_attribute *attr);
+ static char *CopyReadOidAttr(const char *delim, const char *null_print,
+ 							 int null_print_len, CopyReadResult *result,
+ 							 bool *isnull);
+ static bool DetectLineEnd(size_t bytesread);
+ 
  
  /* Internal communications functions */
  static void SendCopyBegin(bool binary, int natts);
***************
*** 160,166 ****
  static void CopySendString(const char *str);
  static void CopySendChar(char c);
  static void CopySendEndOfRow(bool binary);
! static void CopyGetData(void *databuf, int datasize);
  static int	CopyGetChar(void);
  
  #define CopyGetEof()  (fe_eof)
--- 193,199 ----
  static void CopySendString(const char *str);
  static void CopySendChar(char c);
  static void CopySendEndOfRow(bool binary);
! static int	CopyGetData(void *databuf, int datasize);
  static int	CopyGetChar(void);
  
  #define CopyGetEof()  (fe_eof)
***************
*** 171,176 ****
--- 204,213 ----
  static void CopySendInt16(int16 val);
  static int16 CopyGetInt16(void);
  
+ /* new parsing utils */
+ static char *strchrlen(const char *s, int c, size_t len);
+ static char *str2chrlen(const char *s, int c1, int c2, size_t len,
+ 						char *c_found);
  
  /*
   * Send copy start/stop messages for frontend copies.  These have changed
***************
*** 181,187 ****
  {
  	if (PG_PROTOCOL_MAJOR(FrontendProtocol) >= 3)
  	{
! 		/* new way */
  		StringInfoData buf;
  		int16		format = (binary ? 1 : 0);
  		int			i;
--- 218,226 ----
  {
  	if (PG_PROTOCOL_MAJOR(FrontendProtocol) >= 3)
  	{
! 		/*
! 		 * new way
! 		 */
  		StringInfoData buf;
  		int16		format = (binary ? 1 : 0);
  		int			i;
***************
*** 197,221 ****
  	}
  	else if (PG_PROTOCOL_MAJOR(FrontendProtocol) >= 2)
  	{
! 		/* old way */
  		if (binary)
  			ereport(ERROR,
  					(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
! 					 errmsg("COPY BINARY is not supported to stdout or from stdin")));
  		pq_putemptymessage('H');
! 		/* grottiness needed for old COPY OUT protocol */
  		pq_startcopyout();
  		copy_dest = COPY_OLD_FE;
  	}
  	else
  	{
! 		/* very old way */
  		if (binary)
  			ereport(ERROR,
  					(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
! 					 errmsg("COPY BINARY is not supported to stdout or from stdin")));
  		pq_putemptymessage('B');
! 		/* grottiness needed for old COPY OUT protocol */
  		pq_startcopyout();
  		copy_dest = COPY_OLD_FE;
  	}
--- 236,270 ----
  	}
  	else if (PG_PROTOCOL_MAJOR(FrontendProtocol) >= 2)
  	{
! 		/*
! 		 * old way
! 		 */
  		if (binary)
  			ereport(ERROR,
  					(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
! 					 errmsg
! 					 ("COPY BINARY is not supported to stdout or from stdin")));
  		pq_putemptymessage('H');
! 		/*
! 		 * grottiness needed for old COPY OUT protocol
! 		 */
  		pq_startcopyout();
  		copy_dest = COPY_OLD_FE;
  	}
  	else
  	{
! 		/*
! 		 * very old way
! 		 */
  		if (binary)
  			ereport(ERROR,
  					(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
! 					 errmsg
! 					 ("COPY BINARY is not supported to stdout or from stdin")));
  		pq_putemptymessage('B');
! 		/*
! 		 * grottiness needed for old COPY OUT protocol
! 		 */
  		pq_startcopyout();
  		copy_dest = COPY_OLD_FE;
  	}
***************
*** 226,232 ****
  {
  	if (PG_PROTOCOL_MAJOR(FrontendProtocol) >= 3)
  	{
! 		/* new way */
  		StringInfoData buf;
  		int16		format = (binary ? 1 : 0);
  		int			i;
--- 275,283 ----
  {
  	if (PG_PROTOCOL_MAJOR(FrontendProtocol) >= 3)
  	{
! 		/*
! 		 * new way
! 		 */
  		StringInfoData buf;
  		int16		format = (binary ? 1 : 0);
  		int			i;
***************
*** 242,266 ****
  	}
  	else if (PG_PROTOCOL_MAJOR(FrontendProtocol) >= 2)
  	{
! 		/* old way */
  		if (binary)
  			ereport(ERROR,
  					(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
! 					 errmsg("COPY BINARY is not supported to stdout or from stdin")));
  		pq_putemptymessage('G');
  		copy_dest = COPY_OLD_FE;
  	}
  	else
  	{
! 		/* very old way */
  		if (binary)
  			ereport(ERROR,
  					(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
! 					 errmsg("COPY BINARY is not supported to stdout or from stdin")));
  		pq_putemptymessage('D');
  		copy_dest = COPY_OLD_FE;
  	}
! 	/* We *must* flush here to ensure FE knows it can send. */
  	pq_flush();
  }
  
--- 293,325 ----
  	}
  	else if (PG_PROTOCOL_MAJOR(FrontendProtocol) >= 2)
  	{
! 		/*
! 		 * old way
! 		 */
  		if (binary)
  			ereport(ERROR,
  					(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
! 					 errmsg
! 					 ("COPY BINARY is not supported to stdout or from stdin")));
  		pq_putemptymessage('G');
  		copy_dest = COPY_OLD_FE;
  	}
  	else
  	{
! 		/*
! 		 * very old way
! 		 */
  		if (binary)
  			ereport(ERROR,
  					(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
! 					 errmsg
! 					 ("COPY BINARY is not supported to stdout or from stdin")));
  		pq_putemptymessage('D');
  		copy_dest = COPY_OLD_FE;
  	}
! 	/*
! 	 * We *must* flush here to ensure FE knows it can send.
! 	 */
  	pq_flush();
  }
  
***************
*** 271,290 ****
  	{
  		if (binary)
  		{
! 			/* Need to flush out file trailer word */
  			CopySendEndOfRow(true);
  		}
  		else
  		{
! 			/* Shouldn't have any unsent data */
  			Assert(copy_msgbuf->len == 0);
  		}
! 		/* Send Copy Done message */
  		pq_putemptymessage('c');
  	}
  	else
  	{
! 		/* The FE/BE protocol uses \n as newline for all platforms */
  		CopySendData("\\.\n", 3);
  		pq_endcopyout(false);
  	}
--- 330,357 ----
  	{
  		if (binary)
  		{
! 			/*
! 			 * Need to flush out file trailer word
! 			 */
  			CopySendEndOfRow(true);
  		}
  		else
  		{
! 			/*
! 			 * Shouldn't have any unsent data 
! 			 */
  			Assert(copy_msgbuf->len == 0);
  		}
! 		/*
! 		 * Send Copy Done message
! 		 */
  		pq_putemptymessage('c');
  	}
  	else
  	{
! 		/*
! 		 * The FE/BE protocol uses \n as newline for all platforms
! 		 */
  		CopySendData("\\.\n", 3);
  		pq_endcopyout(false);
  	}
***************
*** 314,323 ****
  		case COPY_OLD_FE:
  			if (pq_putbytes((char *) databuf, datasize))
  			{
! 				/* no hope of recovering connection sync, so FATAL */
  				ereport(FATAL,
  						(errcode(ERRCODE_CONNECTION_FAILURE),
! 					   errmsg("connection lost during COPY to stdout")));
  			}
  			break;
  		case COPY_NEW_FE:
--- 381,392 ----
  		case COPY_OLD_FE:
  			if (pq_putbytes((char *) databuf, datasize))
  			{
! 				/*
! 				 * no hope of recovering connection sync, so FATAL
! 				 */
  				ereport(FATAL,
  						(errcode(ERRCODE_CONNECTION_FAILURE),
! 						 errmsg("connection lost during COPY to stdout")));
  			}
  			break;
  		case COPY_NEW_FE:
***************
*** 346,352 ****
  		case COPY_FILE:
  			if (!binary)
  			{
! 				/* Default line termination depends on platform */
  #ifndef WIN32
  				CopySendChar('\n');
  #else
--- 415,423 ----
  		case COPY_FILE:
  			if (!binary)
  			{
! 				/*
! 				 * Default line termination depends on platform
! 				 */
  #ifndef WIN32
  				CopySendChar('\n');
  #else
***************
*** 355,371 ****
  			}
  			break;
  		case COPY_OLD_FE:
! 			/* The FE/BE protocol uses \n as newline for all platforms */
  			if (!binary)
  				CopySendChar('\n');
  			break;
  		case COPY_NEW_FE:
! 			/* The FE/BE protocol uses \n as newline for all platforms */
  			if (!binary)
  				CopySendChar('\n');
! 			/* Dump the accumulated row as one CopyData message */
  			(void) pq_putmessage('d', copy_msgbuf->data, copy_msgbuf->len);
! 			/* Reset copy_msgbuf to empty */
  			copy_msgbuf->len = 0;
  			copy_msgbuf->data[0] = '\0';
  			break;
--- 426,450 ----
  			}
  			break;
  		case COPY_OLD_FE:
! 			/*
! 			 * The FE/BE protocol uses \n as newline for all platforms
! 			 */
  			if (!binary)
  				CopySendChar('\n');
  			break;
  		case COPY_NEW_FE:
! 			/*
! 			 * The FE/BE protocol uses \n as newline for all platforms
! 			 */
  			if (!binary)
  				CopySendChar('\n');
! 			/*
! 			 * Dump the accumulated row as one CopyData message
! 			 */
  			(void) pq_putmessage('d', copy_msgbuf->data, copy_msgbuf->len);
! 			/*
! 			 * Reset copy_msgbuf to empty
! 			 */
  			copy_msgbuf->len = 0;
  			copy_msgbuf->data[0] = '\0';
  			break;
***************
*** 383,407 ****
   * It seems unwise to allow the COPY IN to complete normally in that case.
   *
   * NB: no data conversion is applied by these functions
   */
! static void
  CopyGetData(void *databuf, int datasize)
  {
  	switch (copy_dest)
  	{
  		case COPY_FILE:
! 			fread(databuf, datasize, 1, copy_file);
  			if (feof(copy_file))
  				fe_eof = true;
  			break;
  		case COPY_OLD_FE:
  			if (pq_getbytes((char *) databuf, datasize))
  			{
! 				/* Only a \. terminator is legal EOF in old protocol */
  				ereport(ERROR,
  						(errcode(ERRCODE_CONNECTION_FAILURE),
  						 errmsg("unexpected EOF on client connection")));
  			}
  			break;
  		case COPY_NEW_FE:
  			while (datasize > 0 && !fe_eof)
--- 462,494 ----
   * It seems unwise to allow the COPY IN to complete normally in that case.
   *
   * NB: no data conversion is applied by these functions
+  *
+  * Returns: the number of bytes that were successfully read
+  * into the data buffer.
   */
! static int
  CopyGetData(void *databuf, int datasize)
  {
+ 	size_t		bytesread = 0;
+ 
  	switch (copy_dest)
  	{
  		case COPY_FILE:
! 			bytesread = fread(databuf, 1, datasize, copy_file);
  			if (feof(copy_file))
  				fe_eof = true;
  			break;
  		case COPY_OLD_FE:
  			if (pq_getbytes((char *) databuf, datasize))
  			{
! 				/*
! 				 * Only a \. terminator is legal EOF in old protocol
! 				 */
  				ereport(ERROR,
  						(errcode(ERRCODE_CONNECTION_FAILURE),
  						 errmsg("unexpected EOF on client connection")));
  			}
+ 			bytesread += datasize;		/* update the count of bytes that were read so far */
  			break;
  		case COPY_NEW_FE:
  			while (datasize > 0 && !fe_eof)
***************
*** 410,441 ****
  
  				while (copy_msgbuf->cursor >= copy_msgbuf->len)
  				{
! 					/* Try to receive another message */
  					int			mtype;
  
! 			readmessage:
  					mtype = pq_getbyte();
  					if (mtype == EOF)
  						ereport(ERROR,
  								(errcode(ERRCODE_CONNECTION_FAILURE),
! 						 errmsg("unexpected EOF on client connection")));
  					if (pq_getmessage(copy_msgbuf, 0))
  						ereport(ERROR,
  								(errcode(ERRCODE_CONNECTION_FAILURE),
! 						 errmsg("unexpected EOF on client connection")));
  					switch (mtype)
  					{
  						case 'd':		/* CopyData */
  							break;
  						case 'c':		/* CopyDone */
! 							/* COPY IN correctly terminated by frontend */
  							fe_eof = true;
! 							return;
  						case 'f':		/* CopyFail */
  							ereport(ERROR,
  									(errcode(ERRCODE_QUERY_CANCELED),
  									 errmsg("COPY from stdin failed: %s",
! 										 pq_getmsgstring(copy_msgbuf))));
  							break;
  						case 'H':		/* Flush */
  						case 'S':		/* Sync */
--- 497,534 ----
  
  				while (copy_msgbuf->cursor >= copy_msgbuf->len)
  				{
! 					/*
! 					 * Try to receive another message
! 					 */
  					int			mtype;
  
! 				  readmessage:
  					mtype = pq_getbyte();
  					if (mtype == EOF)
  						ereport(ERROR,
  								(errcode(ERRCODE_CONNECTION_FAILURE),
! 								 errmsg
! 								 ("unexpected EOF on client connection")));
  					if (pq_getmessage(copy_msgbuf, 0))
  						ereport(ERROR,
  								(errcode(ERRCODE_CONNECTION_FAILURE),
! 								 errmsg
! 								 ("unexpected EOF on client connection")));
  					switch (mtype)
  					{
  						case 'd':		/* CopyData */
  							break;
  						case 'c':		/* CopyDone */
! 							/*
! 							 * COPY IN correctly terminated by frontend
! 							 */
  							fe_eof = true;
! 							return bytesread;
  						case 'f':		/* CopyFail */
  							ereport(ERROR,
  									(errcode(ERRCODE_QUERY_CANCELED),
  									 errmsg("COPY from stdin failed: %s",
! 											pq_getmsgstring(copy_msgbuf))));
  							break;
  						case 'H':		/* Flush */
  						case 'S':		/* Sync */
***************
*** 450,457 ****
  						default:
  							ereport(ERROR,
  									(errcode(ERRCODE_PROTOCOL_VIOLATION),
! 									 errmsg("unexpected message type 0x%02X during COPY from stdin",
! 											mtype)));
  							break;
  					}
  				}
--- 543,551 ----
  						default:
  							ereport(ERROR,
  									(errcode(ERRCODE_PROTOCOL_VIOLATION),
! 									 errmsg
! 									 ("unexpected message type 0x%02X during COPY from stdin",
! 									  mtype)));
  							break;
  					}
  				}
***************
*** 460,469 ****
--- 554,566 ----
  					avail = datasize;
  				pq_copymsgbytes(copy_msgbuf, databuf, avail);
  				databuf = (void *) ((char *) databuf + avail);
+ 				bytesread += avail;		/* update the count of bytes that were read so far */
  				datasize -= avail;
  			}
  			break;
  	}
+ 
+ 	return bytesread;
  }
  
  static int
***************
*** 480,486 ****
  			ch = pq_getbyte();
  			if (ch == EOF)
  			{
! 				/* Only a \. terminator is legal EOF in old protocol */
  				ereport(ERROR,
  						(errcode(ERRCODE_CONNECTION_FAILURE),
  						 errmsg("unexpected EOF on client connection")));
--- 577,585 ----
  			ch = pq_getbyte();
  			if (ch == EOF)
  			{
! 				/*
! 				 * Only a \. terminator is legal EOF in old protocol
! 				 */
  				ereport(ERROR,
  						(errcode(ERRCODE_CONNECTION_FAILURE),
  						 errmsg("unexpected EOF on client connection")));
***************
*** 529,535 ****
  			ch = pq_peekbyte();
  			if (ch == EOF)
  			{
! 				/* Only a \. terminator is legal EOF in old protocol */
  				ereport(ERROR,
  						(errcode(ERRCODE_CONNECTION_FAILURE),
  						 errmsg("unexpected EOF on client connection")));
--- 628,636 ----
  			ch = pq_peekbyte();
  			if (ch == EOF)
  			{
! 				/*
! 				 * Only a \. terminator is legal EOF in old protocol
! 				 */
  				ereport(ERROR,
  						(errcode(ERRCODE_CONNECTION_FAILURE),
  						 errmsg("unexpected EOF on client connection")));
***************
*** 565,579 ****
  		case COPY_FILE:
  			if (!pickup)
  			{
! 				/* We don't want to pick it up - so put it back in there */
  				ungetc(c, copy_file);
  			}
! 			/* If we wanted to pick it up, it's already done */
  			break;
  		case COPY_OLD_FE:
  			if (pickup)
  			{
! 				/* We want to pick it up */
  				(void) pq_getbyte();
  			}
  
--- 666,686 ----
  		case COPY_FILE:
  			if (!pickup)
  			{
! 				/*
! 				 * We don't want to pick it up - so put it back in there 
! 				 */
  				ungetc(c, copy_file);
  			}
! 			/*
! 			 * If we wanted to pick it up, it's already done 
! 			 */
  			break;
  		case COPY_OLD_FE:
  			if (pickup)
  			{
! 				/*
! 				 * We want to pick it up
! 				 */
  				(void) pq_getbyte();
  			}
  
***************
*** 585,594 ****
  		case COPY_NEW_FE:
  			if (!pickup)
  			{
! 				/* We don't want to pick it up - so put it back in there */
  				copy_msgbuf->cursor--;
  			}
! 			/* If we wanted to pick it up, it's already done */
  			break;
  	}
  }
--- 692,705 ----
  		case COPY_NEW_FE:
  			if (!pickup)
  			{
! 				/*
! 				 * We don't want to pick it up - so put it back in there 
! 				 */
  				copy_msgbuf->cursor--;
  			}
! 			/*
! 			 * If we wanted to pick it up, it's already done 
! 			 */
  			break;
  	}
  }
***************
*** 695,701 ****
  	bool		binary = false;
  	bool		oids = false;
  	bool		csv_mode = false;
! 	bool        header_line = false;
  	char	   *delim = NULL;
  	char	   *quote = NULL;
  	char	   *escape = NULL;
--- 806,812 ----
  	bool		binary = false;
  	bool		oids = false;
  	bool		csv_mode = false;
! 	bool		header_line = false;
  	char	   *delim = NULL;
  	char	   *quote = NULL;
  	char	   *escape = NULL;
***************
*** 708,714 ****
  	AclMode		required_access = (is_from ? ACL_INSERT : ACL_SELECT);
  	AclResult	aclresult;
  
! 	/* Extract options from the statement node tree */
  	foreach(option, stmt->options)
  	{
  		DefElem    *defel = (DefElem *) lfirst(option);
--- 819,827 ----
  	AclMode		required_access = (is_from ? ACL_INSERT : ACL_SELECT);
  	AclResult	aclresult;
  
! 	/*
! 	 * Extract options from the statement node tree
! 	 */
  	foreach(option, stmt->options)
  	{
  		DefElem    *defel = (DefElem *) lfirst(option);
***************
*** 794,801 ****
  			force_notnull = (List *) defel->arg;
  		}
  		else
! 			elog(ERROR, "option \"%s\" not recognized",
! 				 defel->defname);
  	}
  
  	if (binary && delim)
--- 907,913 ----
  			force_notnull = (List *) defel->arg;
  		}
  		else
! 			elog(ERROR, "option \"%s\" not recognized", defel->defname);
  	}
  
  	if (binary && delim)
***************
*** 813,819 ****
  				(errcode(ERRCODE_SYNTAX_ERROR),
  				 errmsg("cannot specify NULL in BINARY mode")));
  
! 	/* Set defaults */
  	if (!delim)
  		delim = csv_mode ? "," : "\t";
  
--- 925,933 ----
  				(errcode(ERRCODE_SYNTAX_ERROR),
  				 errmsg("cannot specify NULL in BINARY mode")));
  
! 	/*
! 	 * Set defaults
! 	 */
  	if (!delim)
  		delim = csv_mode ? "," : "\t";
  
***************
*** 828,846 ****
  			escape = quote;
  	}
  
! 	/* Only single-character delimiter strings are supported. */
  	if (strlen(delim) != 1)
  		ereport(ERROR,
  				(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
  				 errmsg("COPY delimiter must be a single character")));
  
!   	/* Check header */
  	if (!csv_mode && header_line)
  		ereport(ERROR,
  				(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
  				 errmsg("COPY HEADER available only in CSV mode")));
  
! 	/* Check quote */
  	if (!csv_mode && quote != NULL)
  		ereport(ERROR,
  				(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
--- 942,968 ----
  			escape = quote;
  	}
  
! 	escapec = '\\';				/* will be configurable in the future */
! 
! 	/*
! 	 * Only single-character delimiter strings are supported.
! 	 */
  	if (strlen(delim) != 1)
  		ereport(ERROR,
  				(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
  				 errmsg("COPY delimiter must be a single character")));
  
! 	/*
! 	 * Check header
! 	 */
  	if (!csv_mode && header_line)
  		ereport(ERROR,
  				(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
  				 errmsg("COPY HEADER available only in CSV mode")));
  
! 	/*
! 	 * Check quote
! 	 */
  	if (!csv_mode && quote != NULL)
  		ereport(ERROR,
  				(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
***************
*** 851,857 ****
  				(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
  				 errmsg("COPY quote must be a single character")));
  
! 	/* Check escape */
  	if (!csv_mode && escape != NULL)
  		ereport(ERROR,
  				(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
--- 973,981 ----
  				(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
  				 errmsg("COPY quote must be a single character")));
  
! 	/*
! 	 * Check escape
! 	 */
  	if (!csv_mode && escape != NULL)
  		ereport(ERROR,
  				(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
***************
*** 862,868 ****
  				(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
  				 errmsg("COPY escape must be a single character")));
  
! 	/* Check force_quote */
  	if (!csv_mode && force_quote != NIL)
  		ereport(ERROR,
  				(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
--- 986,994 ----
  				(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
  				 errmsg("COPY escape must be a single character")));
  
! 	/*
! 	 * Check force_quote
! 	 */
  	if (!csv_mode && force_quote != NIL)
  		ereport(ERROR,
  				(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
***************
*** 870,909 ****
  	if (force_quote != NIL && is_from)
  		ereport(ERROR,
  				(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
! 			   errmsg("COPY force quote only available using COPY TO")));
  
! 	/* Check force_notnull */
  	if (!csv_mode && force_notnull != NIL)
  		ereport(ERROR,
  				(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
! 			  errmsg("COPY force not null available only in CSV mode")));
  	if (force_notnull != NIL && !is_from)
  		ereport(ERROR,
  				(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
! 		  errmsg("COPY force not null only available using COPY FROM")));
  
! 	/* Don't allow the delimiter to appear in the null string. */
  	if (strchr(null_print, delim[0]) != NULL)
  		ereport(ERROR,
  				(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
! 				 errmsg("COPY delimiter must not appear in the NULL specification")));
  
! 	/* Don't allow the csv quote char to appear in the null string. */
  	if (csv_mode && strchr(null_print, quote[0]) != NULL)
  		ereport(ERROR,
  				(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
! 				 errmsg("CSV quote character must not appear in the NULL specification")));
  
! 	/* Open and lock the relation, using the appropriate lock type. */
! 	rel = heap_openrv(relation, (is_from ? RowExclusiveLock : AccessShareLock));
  
! 	/* check read-only transaction */
! 	if (XactReadOnly && !is_from && !isTempNamespace(RelationGetNamespace(rel)))
  		ereport(ERROR,
  				(errcode(ERRCODE_READ_ONLY_SQL_TRANSACTION),
  				 errmsg("transaction is read-only")));
  
! 	/* Check permissions. */
  	aclresult = pg_class_aclcheck(RelationGetRelid(rel), GetUserId(),
  								  required_access);
  	if (aclresult != ACLCHECK_OK)
--- 996,1052 ----
  	if (force_quote != NIL && is_from)
  		ereport(ERROR,
  				(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
! 				 errmsg("COPY force quote only available using COPY TO")));
  
! 	/*
! 	 * Check force_notnull
! 	 */
  	if (!csv_mode && force_notnull != NIL)
  		ereport(ERROR,
  				(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
! 				 errmsg("COPY force not null available only in CSV mode")));
  	if (force_notnull != NIL && !is_from)
  		ereport(ERROR,
  				(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
! 				 errmsg
! 				 ("COPY force not null only available using COPY FROM")));
  
! 	/*
! 	 * Don't allow the delimiter to appear in the null string. 
! 	 */
  	if (strchr(null_print, delim[0]) != NULL)
  		ereport(ERROR,
  				(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
! 				 errmsg
! 				 ("COPY delimiter must not appear in the NULL specification")));
  
! 	/*
! 	 * Don't allow the csv quote char to appear in the null string. 
! 	 */
  	if (csv_mode && strchr(null_print, quote[0]) != NULL)
  		ereport(ERROR,
  				(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
! 				 errmsg
! 				 ("CSV quote character must not appear in the NULL specification")));
  
! 	/*
! 	 * Open and lock the relation, using the appropriate lock type.
! 	 */
! 	rel =
! 		heap_openrv(relation, (is_from ? RowExclusiveLock : AccessShareLock));
  
! 	/*
! 	 * check read-only transaction
! 	 */
! 	if (XactReadOnly && !is_from
! 		&& !isTempNamespace(RelationGetNamespace(rel)))
  		ereport(ERROR,
  				(errcode(ERRCODE_READ_ONLY_SQL_TRANSACTION),
  				 errmsg("transaction is read-only")));
  
! 	/*
! 	 * Check permissions.
! 	 */
  	aclresult = pg_class_aclcheck(RelationGetRelid(rel), GetUserId(),
  								  required_access);
  	if (aclresult != ACLCHECK_OK)
